From 79c20a3f8d94bdb4cfde08830747f32b0d2aabd9 Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: May 17 2019 09:36:42 +0000
Subject: [PATCH 11/88] automatic generation of site.yml for languages


---

diff --git a/prepare-translated.py b/prepare-translated.py
new file mode 100755
index 0000000..d81f9bb
--- /dev/null
+++ b/prepare-translated.py
@@ -0,0 +1,48 @@
+#!/usr/bin/env python3
+"""Prepare site.yml for each translated sites"""
+
+import os
+import subprocess
+import tempfile
+import yaml
+
+def main():
+    """ Read site.yml content, replace `sources` content with localized content"""
+    lang_sources = get_language_sources()
+
+    with open("site.yml", 'r') as stream:
+        data_loaded = yaml.load(stream, Loader=yaml.SafeLoader)
+
+    for lang in lang_sources:
+        print(lang)
+
+        with open('site-'+lang+'.yml', 'w') as outfile:
+            data_loaded['content']['sources'] = lang_sources[lang]
+            yaml.dump(data_loaded, outfile, default_flow_style=False)
+
+
+def get_language_sources():
+    """ Get the list of languages + modules + branches from translated-sources"""
+    sources = {}
+    with tempfile.TemporaryDirectory() as tmp:
+        t_sources_url = "https://pagure.io/fedora-docs/translated-sources.git"
+        subprocess.run(["git", "clone", t_sources_url], check=True, cwd=tmp)
+
+        path = tmp+"/translated-sources"
+
+        # we don't want ".git" folder
+        langs = [d for d in next(os.walk(path))[1] if not d[0] == '.']
+        for lang in langs:
+            sources[lang] = []
+            for module in next(os.walk(path+"/"+lang))[1]:
+                for branch in next(os.walk(path+"/"+lang + "/" + module))[1]:
+                    hop = {}
+                    hop["url"] = t_sources_url
+                    hop["start_path"] = lang+"/"+module+"/"+branch
+                    sources[lang].append(hop)
+
+    return sources
+
+
+if __name__ == '__main__':
+    main()
